#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import locale
import gettext

APP = 'translate-me'
DIR = '/usr/share/locale-langpack'

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext


class Language:
	def __init__(self):
		self.idioms = {}
		self.idioms[_('Afrikaans').capitalize()]='af'
		self.idioms[_('Albanian').capitalize()]='sq'
		self.idioms[_('Amharic').capitalize()]='am'
		self.idioms[_('Arabic').capitalize()]='ar'
		self.idioms[_('Armenian').capitalize()]='hy'
		self.idioms[_('Azerbaijani').capitalize()]='az'
		self.idioms[_('Basque').capitalize()]='eu'
		self.idioms[_('Belarusian').capitalize()]='be'
		self.idioms[_('Bengali').capitalize()]='bn'
		self.idioms[_('Bihari').capitalize()]='bh'
		self.idioms[_('Breton').capitalize()]='br'
		self.idioms[_('Bulgarian').capitalize()]='bg'
		self.idioms[_('Burmese').capitalize()]='my'
		self.idioms[_('Catalan').capitalize()]='ca'
		self.idioms[_('Cherokee').capitalize()]='chr'
		self.idioms[_('Chinese').capitalize()]='zh'
		self.idioms[_('Chinese_simplified').capitalize()]='zh-CN'
		self.idioms[_('Chinese_traditional').capitalize()]='zh-TW'
		self.idioms[_('Corsican').capitalize()]='co'
		self.idioms[_('Croatian').capitalize()]='hr'
		self.idioms[_('Czech').capitalize()]='cs'
		self.idioms[_('Danish').capitalize()]='da'
		self.idioms[_('Dhivehi').capitalize()]='dv'
		self.idioms[_('Dutch').capitalize()]='nl'  
		self.idioms[_('English').capitalize()]='en'
		self.idioms[_('Esperanto').capitalize()]='eo'
		self.idioms[_('Estonian').capitalize()]='et'
		self.idioms[_('Faroese').capitalize()]='fo'
		self.idioms[_('Filipino').capitalize()]='tl'
		self.idioms[_('Finnish').capitalize()]='fi'
		self.idioms[_('French').capitalize()]='fr'
		self.idioms[_('Frisian').capitalize()]='fy'
		self.idioms[_('Galician').capitalize()]='gl'
		self.idioms[_('Georgian').capitalize()]='ka'
		self.idioms[_('German').capitalize()]='de'
		self.idioms[_('Greek').capitalize()]='el'
		self.idioms[_('Gujarati').capitalize()]='gu'
		self.idioms[_('Haitian_creole').capitalize()]='ht'
		self.idioms[_('Hebrew').capitalize()]='iw'
		self.idioms[_('Hindi').capitalize()]='hi'
		self.idioms[_('Hungarian').capitalize()]='hu'
		self.idioms[_('Icelandic').capitalize()]='is'
		self.idioms[_('Indonesian').capitalize()]='id'
		self.idioms[_('Inuktitut').capitalize()]='iu'
		self.idioms[_('Irish').capitalize()]='ga'
		self.idioms[_('Italian').capitalize()]='it'
		self.idioms[_('Japanese').capitalize()]='ja'
		self.idioms[_('Javanese').capitalize()]='jw'
		self.idioms[_('Kannada').capitalize()]='kn'
		self.idioms[_('Kazakh').capitalize()]='kk'
		self.idioms[_('Khmer').capitalize()]='km'
		self.idioms[_('Korean').capitalize()]='ko'
		self.idioms[_('Kurdish').capitalize()]='ku'
		self.idioms[_('Kyrgyz').capitalize()]='ky'
		self.idioms[_('Lao').capitalize()]='lo'
		self.idioms[_('Latin').capitalize()]='la'
		self.idioms[_('Latvian').capitalize()]='lv'
		self.idioms[_('Lithuanian').capitalize()]='lt'
		self.idioms[_('Luxembourgish').capitalize()]='lb'
		self.idioms[_('Macedonian').capitalize()]='mk'
		self.idioms[_('Malay').capitalize()]='ms'
		self.idioms[_('Malayalam').capitalize()]='ml'
		self.idioms[_('Maltese').capitalize()]='mt'
		self.idioms[_('Maori').capitalize()]='mi'
		self.idioms[_('Marathi').capitalize()]='mr'
		self.idioms[_('Mongolian').capitalize()]='mn'
		self.idioms[_('Nepali').capitalize()]='ne'
		self.idioms[_('Norwegian').capitalize()]='no'
		self.idioms[_('Occitan').capitalize()]='oc'
		self.idioms[_('Oriya').capitalize()]='or'
		self.idioms[_('Pashto').capitalize()]='ps'
		self.idioms[_('Persian').capitalize()]='fa'
		self.idioms[_('Polish').capitalize()]='pl'
		self.idioms[_('Portuguese').capitalize()]='pt'
		self.idioms[_('Portuguese_portugal').capitalize()]='pt-PT'
		self.idioms[_('Punjabi').capitalize()]='pa'
		self.idioms[_('Quechua').capitalize()]='qu'
		self.idioms[_('Romanian').capitalize()]='ro'
		self.idioms[_('Russian').capitalize()]='ru'
		self.idioms[_('Sanskrit').capitalize()]='sa'
		self.idioms[_('Scots_gaelic').capitalize()]='gd'
		self.idioms[_('Serbian').capitalize()]='sr'
		self.idioms[_('Sindhi').capitalize()]='sd'
		self.idioms[_('Sinhalese').capitalize()]='si'
		self.idioms[_('Slovak').capitalize()]='sk'
		self.idioms[_('Slovenian').capitalize()]='sl'
		self.idioms[_('Spanish').capitalize()]='es'
		self.idioms[_('Sundanese').capitalize()]='su'
		self.idioms[_('Swahili').capitalize()]='sw'
		self.idioms[_('Swedish').capitalize()]='sv'
		self.idioms[_('Syriac').capitalize()]='syr'
		self.idioms[_('Tajik').capitalize()]='tg'
		self.idioms[_('Tamil').capitalize()]='ta'
		self.idioms[_('Tatar').capitalize()]='tt'
		self.idioms[_('Telugu').capitalize()]='te'
		self.idioms[_('Thai').capitalize()]='th'
		self.idioms[_('Tibetan').capitalize()]='bo'
		self.idioms[_('Tonga').capitalize()]='to'
		self.idioms[_('Turkish').capitalize()]='tr'
		self.idioms[_('Ukrainian').capitalize()]='uk'
		self.idioms[_('Urdu').capitalize()]='ur'
		self.idioms[_('Uzbek').capitalize()]='uz'
		self.idioms[_('Uighur').capitalize()]='ug'
		self.idioms[_('Vietnamese').capitalize()]='vi'
		self.idioms[_('Welsh').capitalize()]='cy'
		self.idioms[_('Yiddish').capitalize()]='yi'
		self.idioms[_('Yoruba').capitalize()]='yo'
		self.idiom_list=self.idioms.keys()
		self.idiom_list.sort()

	def get_language_code(self,language_name):
		return self.idioms[language_name]

	def get_list_of_languages(self):
		return self.idiom_list
