#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#

import gtk
import locale
import gettext
import comun
from language import Language
from configurator import GConf
from Crypto.Cipher import AES
import base64

# the block size for the cipher object; must be 16, 24, or 32 for AES
BLOCK_SIZE = 32

# the character used for padding--with a block cipher such as AES, the value
# you encrypt must be a multiple of BLOCK_SIZE in length.  This character is
# used to ensure that your value is always a multiple of BLOCK_SIZE
PADDING = '&'

MK = 'YlF1YfNqaLpgRQ21rlyOpM1RpHztgKhi9t7YAB9+3i8=CDYU/qPgmqo4bzeqqvG86GeXgZYrPFc0RgkjEx2NCaE=GAfPmvXMxZrh1sBwnM4QbRF65EcOirhjU0lAFJWhe+I=4SnMYszjwos5XUCTxDp7a5pe4fcxt/EWP/iQ96h1WNA=/g689L9NBj0wNdSSu48jEL5bGpsoDv6JlIxi0cJ3LGI='

class Encoder:
	def __init__(self):
		AE=MK[30:80]
		self.cipher = AES.new(self.pad(AE[10:41]))
	
	def encode(self,cadena):
		return base64.b64encode(self.cipher.encrypt(self.pad(cadena)))
	
	def decode(self,cadena):
		return self.cipher.decrypt(base64.b64decode(cadena)).rstrip(PADDING)
	
	def pad(self,cadena):
		return cadena + (BLOCK_SIZE - len(cadena) % BLOCK_SIZE) * PADDING


locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(comun.APP, comun.LANGDIR)
gettext.textdomain(comun.APP)
_ = gettext.gettext

class Preferences(gtk.Dialog):
	def __init__(self):
		self.language = Language()
		'''
		# Con estas dos líneas corregimos el problema de que no exista el directorio de origen
		if os.path.exists(os.path.join(os.getenv("HOME"),".translate-me/"))==False:
			os.mkdir(os.path.join(os.getenv("HOME"),".translate-me/"))
		filename = os.path.join(os.getenv("HOME"),".translate-me/translate-me.ini")
		self.ini=Ini(filename)
		'''
		#
		gtk.Dialog.__init__(self)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_title('translate-me | '+_('Preferences'))
		self.set_default_size(50, 250)
		self.set_icon(gtk.gdk.pixbuf_new_from_file(comun.absfile('tm.svg')))
		self.connect('destroy', self.close_application)
		#
		vbox0 = gtk.VBox(spacing = 5)
		vbox0.set_border_width(5)
		self.get_content_area().add(vbox0)
		#
		notebook = gtk.Notebook()
		vbox0.add(notebook)
		#
		vbox1 = gtk.VBox(spacing = 5)
		vbox1.set_border_width(5)
		notebook.append_page(vbox1,gtk.Label(_('Idioms')))
		#
		vbox2 = gtk.VBox(spacing = 5)
		vbox2.set_border_width(5)
		notebook.append_page(vbox2,gtk.Label(_('Proxy')))
		#
		vbox3 = gtk.VBox(spacing = 5)
		vbox3.set_border_width(5)
		notebook.append_page(vbox3,gtk.Label(_('Text size')))
		#
		hbox11 = gtk.HBox()
		vbox1.pack_start(hbox11,False,False)
		#
		label11 = gtk.Label(_('From')+':')
		hbox11.pack_start(label11,False,False)
		#
		self.combobox1 = gtk.ComboBox()
		hbox11.pack_start(self.combobox1,True,True)
		#
		hbox12 = gtk.HBox()
		vbox1.pack_start(hbox12,False,False)
		#
		label12 = gtk.Label(_('To')+':')
		hbox12.pack_start(label12,False,False)
		#
		self.combobox2 = gtk.ComboBox()
		hbox12.pack_start(self.combobox2,True,True)
		#
		hbox21 = gtk.HBox()
		vbox2.pack_start(hbox21,False,False)
		#
		label21 = gtk.Label(_('Use proxy')+':')
		hbox21.pack_start(label21,False,False)
		#
		self.checkbutton1 = gtk.CheckButton()
		hbox21.pack_start(self.checkbutton1,True,True)
		#
		hbox22 = gtk.HBox()
		vbox2.pack_start(hbox22,False,False)
		#
		label22 = gtk.Label(_('Server')+':')
		hbox22.pack_start(label22,False,False)
		#
		self.entry1 = gtk.Entry()
		hbox22.pack_start(self.entry1,True,True)
		#
		hbox23 = gtk.HBox()
		vbox2.pack_start(hbox23,False,False)
		#
		label23 = gtk.Label(_('Port')+':')
		hbox23.pack_start(label23,False,False)
		#
		self.entry2 = gtk.Entry()
		hbox23.pack_start(self.entry2,True,True)
		#
		hbox24 = gtk.HBox()
		vbox2.pack_start(hbox24,False,False)
		#
		label24 = gtk.Label(_('User')+':')
		hbox24.pack_start(label24,False,False)
		#
		self.entry3 = gtk.Entry()
		hbox24.pack_start(self.entry3,True,True)
		#
		hbox25 = gtk.HBox()
		vbox2.pack_start(hbox25,False,False)
		#
		label25 = gtk.Label(_('Password')+':')
		hbox25.pack_start(label25,False,False)
		#
		self.entry4 = gtk.Entry()
		self.entry4.set_visibility(False)
		hbox25.pack_start(self.entry4,True,True)
		#
		self.fontbutton1 = gtk.FontButton()
		vbox3.pack_start(self.fontbutton1,False,False)
		#
		self.fontbutton2 = gtk.FontButton('Ubuntu 12')
		vbox3.pack_start(self.fontbutton2,False,False)
		#
		hbox26 = gtk.HBox()
		hbox26.set_border_width(5)
		vbox0.pack_start(hbox26,False,False)
		#
		self.button1 = gtk.Button(_('Ok'))
		self.button1.connect('clicked',self.on_button1_clicked)
		hbox26.pack_start(self.button1,True,False)
		#
		self.button2 = gtk.Button(_('Cancel'))
		self.button2.connect('clicked',self.on_button2_clicked)
		hbox26.pack_start(self.button2,True,False)


		#
		self.model = gtk.ListStore(str)
		for idiom in self.language.get_list_of_languages():
			self.model.append([idiom])
		#
		self.combobox1.set_model(self.model)
		cell = gtk.CellRendererText()
		self.combobox1.pack_start(cell,True);
		self.combobox1.add_attribute(cell,'text',0)
		#
		self.combobox2.set_model(self.model)
		cell = gtk.CellRendererText()
		self.combobox2.pack_start(cell,True);
		self.combobox2.add_attribute(cell,'text',0)
		#
		self.load_preferences()
		#
		self.show_all()

	def load_preferences(self):
		encoder = Encoder()
		self.de = self.load_key('de',0)
		self.a = self.load_key('a',0)
		self.proxy = self.load_key('proxy',False)
		self.server = self.load_key('server','')
		self.port = self.load_key('port',0)
		self.user = self.load_key('user',encoder.encode(''))
		self.password = self.load_key('password',encoder.encode(''))
		self.font_from = self.load_key('font_from','Ubuntu 12')
		self.font_to = self.load_key('font_to','Ubuntu 12')
		#
		self.combobox1.set_active(self.de)
		self.combobox2.set_active(self.a)
		self.checkbutton1.set_active(self.proxy)
		self.entry1.set_text(self.server)
		self.entry2.set_text(str(self.port))
		self.entry3.set_text(encoder.decode(self.user))
		self.entry4.set_text(encoder.decode(self.password))
		self.fontbutton1.set_font_name(self.font_from)
		self.fontbutton2.set_font_name(self.font_to)

	def load_key(self,key,defecto):
		gconfi = GConf()
		PATH = '/apps/translate-me/options/'+key
		try:
			valor = gconfi.get_key(PATH)
			return valor
		except ValueError:
			gconfi.set_key(PATH,defecto)
		return defecto
		
	def save_preferences(self):
		gconfi = GConf()
		gconfi.set_key('/apps/translate-me/options/de',self.combobox1.get_active())
		gconfi.set_key('/apps/translate-me/options/a',self.combobox2.get_active())
		gconfi.set_key('/apps/translate-me/options/proxy',self.checkbutton1.get_active())
		gconfi.set_key('/apps/translate-me/options/server',self.entry1.get_text())
		gconfi.set_key('/apps/translate-me/options/port',int(self.entry2.get_text()))
		encoder = Encoder()
		gconfi.set_key('/apps/translate-me/options/user',encoder.encode(self.entry3.get_text()))
		gconfi.set_key('/apps/translate-me/options/password',encoder.encode(self.entry4.get_text()))
		gconfi.set_key('/apps/translate-me/options/font_from',self.fontbutton1.get_font_name())
		gconfi.set_key('/apps/translate-me/options/font_to',self.fontbutton2.get_font_name())
	
	def close_application(self,widget):
		self.hide()
	
	def on_button1_clicked(self,widget):
		self.save_preferences()
		self.hide()
	
	def on_button2_clicked(self,widget):
		self.hide()

if __name__ == "__main__":
	p = Preferences()
	p.run()
	exit(0)
		
