#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import re
import sys
import urllib
import urllib2
import simplejson
import gtk
import pango
import locale
import gettext
import comun
from configurator import GConf
from preferences import Preferences
from preferences import Encoder
from language import Language

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(comun.APP, comun.LANGDIR)
gettext.textdomain(comun.APP)
_ = gettext.gettext

baseUrl = "http://ajax.googleapis.com/ajax/services/language/translate"
 
def getSplits(text,splitLength=4500):
	'''
	Translate Api has a limit on length of text(4500 characters) that can be translated at once, 
	'''
	return (text[index:index+splitLength] for index in xrange(0,len(text),splitLength))
 
 
def translate(text,src='', to='en',useproxies=False,proxies=None):
	'''
	A Python Wrapper for Google AJAX Language API:
	* Uses Google Language Detection, in cases source language is not provided with the source text
	* Splits up text if it's longer then 4500 characters, as a limit put up by the API
	'''

	params = ({'langpair': '%s|%s' % (src, to),
			 'v': '1.0'
			 })
	retText=''
	for text in getSplits(text):
		params['q'] = text
		try:
			if useproxies:
				proxy_support = urllib2.ProxyHandler({"http" : \
				"http://%(user)s:%(pass)s@%(host)s:%(port)d" % proxies})
				opener = urllib2.build_opener(proxy_support, urllib2.HTTPHandler)
				urllib2.install_opener(opener)
				resp = simplejson.load(urllib2.urlopen('%s' % (baseUrl), data = urllib.urlencode(params)))
				#resp = simplejson.load(urllib2.urlopen('%s' % (baseUrl), data = urllib.urlencode(params),proxies=proxies))
			else:
				resp = simplejson.load(urllib2.urlopen('%s' % (baseUrl), data = urllib.urlencode(params)))
			if resp['responseStatus']==200:
				retText += resp['responseData']['translatedText']
				'''	
				try:
						print resp
						retText += resp['responseData']['translatedText']
				except:
						raise
				'''
		except IOError as (errno, strerror):
			msg = 'I/O error({0}): {1}'.format(errno, strerror)
			md = gtk.MessageDialog(None, 
			gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_ERROR, 
			gtk.BUTTONS_OK, msg)
			respuesta=md.run()
			md.destroy()			
			print 'error'
	return retText


class TM(gtk.Dialog):
	def __init__(self):
		self.language = Language()
		#
		gtk.Dialog.__init__(self)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_title('Translate-me')
		self.set_default_size(200, 200)
		self.set_icon(gtk.gdk.pixbuf_new_from_file(comun.absfile('tm.svg')))
		self.connect('destroy', self.close_application)
		#
		vbox = gtk.VBox(spacing = 5)
		vbox.set_border_width(5)
		self.get_content_area().add(vbox)
		#
		self.menubar = gtk.MenuBar()
		################################################################
		self.filemenu = gtk.Menu()
		self.filem = gtk.MenuItem(_('File'))
		self.filem.set_submenu(self.filemenu)
		#
		self.sal = gtk.ImageMenuItem(gtk.STOCK_QUIT)
		self.sal.connect('activate',self.close_application)
		self.filemenu.append(self.sal)
		#
		self.menubar.append(self.filem)
		################################################################
		self.fileedit = gtk.Menu()
		self.filee = gtk.MenuItem(_('Edit'))
		self.filee.set_submenu(self.fileedit)
		#
		self.pref = gtk.ImageMenuItem(gtk.STOCK_PREFERENCES)
		self.pref.connect('activate',self.on_preferences_activate)
		self.fileedit.append(self.pref)
		#
		self.menubar.append(self.filee)
		################################################################
		self.filehelp = gtk.Menu()
		self.fileh = gtk.MenuItem(_('Help'))
		self.fileh.set_submenu(self.filehelp)
		#
		self.about = gtk.ImageMenuItem(gtk.STOCK_ABOUT)
		self.about.connect('activate',self.on_about_activate)
		self.filehelp.append(self.about)
		#
		self.menubar.append(self.fileh)
		################################################################
		vbox.pack_start(self.menubar,False,False)			
		#
		frame = gtk.Frame()
		vbox.add(frame)
		#
		vbox1 = gtk.VBox(spacing = 5)
		vbox1.set_border_width(5)
		frame.add(vbox1)
		#
		hbox1 = gtk.HBox()
		vbox1.pack_start(hbox1,False,False)
		#
		label1 = gtk.Label(_('From')+':')
		hbox1.pack_start(label1,False,False)
		#
		self.combobox1 = gtk.ComboBox()
		hbox1.pack_start(self.combobox1,True,True)
		#
		scrolledwindow1 = gtk.ScrolledWindow()
		scrolledwindow1.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		scrolledwindow1.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
		vbox1.pack_start(scrolledwindow1,True,True)
		self.entry1 = gtk.TextView()
		self.entry1.set_border_width(5)
		scrolledwindow1.add(self.entry1)
		#
		hbox2 = gtk.HBox()
		vbox1.pack_start(hbox2,False,False)
		#
		self.button1 = gtk.Button(_('Translate'))
		self.button1.connect('clicked',self.on_button1_clicked)
		hbox2.pack_start(self.button1,True,True)
		#
		self.button2 = gtk.Button()
		self.button2.add(gtk.Arrow(gtk.ARROW_UP, gtk.SHADOW_OUT))
		self.button2.connect('clicked',self.on_button2_clicked)
		hbox2.pack_start(self.button2,True,True)
		#
		hbox3 = gtk.HBox()
		vbox1.pack_start(hbox3,False,False)
		#
		label2 = gtk.Label(_('To')+':')
		hbox3.pack_start(label2,False,False)
		#
		self.combobox2 = gtk.ComboBox()
		hbox3.pack_start(self.combobox2,True,True)
		#
		scrolledwindow2 = gtk.ScrolledWindow()
		scrolledwindow2.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		scrolledwindow2.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
		vbox1.pack_start(scrolledwindow2,True,True)
		self.entry2 = gtk.TextView()
		self.entry2.set_border_width(5)
		scrolledwindow2.add(self.entry2)
		#
		self.model = gtk.ListStore(str)
		for idiom in self.language.get_list_of_languages():
			self.model.append([idiom])
		#
		self.combobox1.set_model(self.model)
		cell = gtk.CellRendererText()
		self.combobox1.pack_start(cell,True);
		self.combobox1.add_attribute(cell,'text',0)
		
		#
		self.combobox2.set_model(self.model)
		cell = gtk.CellRendererText()
		self.combobox2.pack_start(cell,True);
		self.combobox2.add_attribute(cell,'text',0)
		#
		self.load_preferences()
		self.combobox1.set_active(self.de)
		self.combobox2.set_active(self.a)
		#
		self.show_all()
	
	def on_preferences_activate(self,widget):
		p = Preferences()
		p.run()
		self.load_preferences()
		
	def close_application(self,widget):
		exit(0)
		
	def existe(self,cadena):
		if cadena:
			for element in self.model:
				if element[0].startswith(cadena):
					return True
		return False

	def on_button1_clicked(self,widget):
		tbuffer =self.entry1.get_buffer()
		inicio = tbuffer.get_start_iter()
		fin = tbuffer.get_end_iter()
		text = tbuffer.get_text(inicio,fin)
		#
		de = self.language.get_language_code(self.model.get_value(self.combobox1.get_active_iter(),0))
		a = self.language.get_language_code(self.model.get_value(self.combobox2.get_active_iter(),0))
		#
		if self.proxy:
			encoder=Encoder()
			proxies={
			'user' : encoder.decode(self.user),
			'pass' : encoder.decode(self.password),
			'host' : self.server,
			'port' : self.port
			}
			translated_text=translate(text,src=de,to=a,useproxies=True,proxies=proxies)
		else:
			translated_text=translate(text,src=de,to=a)
		ttbuffer=gtk.TextBuffer()
		ttbuffer.set_text(translated_text)
		self.entry2.set_buffer(ttbuffer)
	
	def on_button2_clicked(self,widget):
		de = self.combobox1.get_active()
		a = self.combobox2.get_active()
		self.combobox1.set_active(a)
		self.combobox2.set_active(de)
		#
		tbuffer =self.entry2.get_buffer()
		inicio = tbuffer.get_start_iter()
		fin = tbuffer.get_end_iter()
		text = tbuffer.get_text(inicio,fin)
		#
		de = self.language.get_language_code(self.model.get_value(self.combobox1.get_active_iter(),0))
		a = self.language.get_language_code(self.model.get_value(self.combobox2.get_active_iter(),0))
		#
		translated_text=translate(text,src=de,to=a)
		ttbuffer=gtk.TextBuffer()
		ttbuffer.set_text(translated_text)
		self.entry1.set_buffer(tbuffer)
		self.entry2.set_buffer(ttbuffer)

	def on_about_activate(self,widget):
		ad=gtk.AboutDialog()
		ad.set_name('Translate-me')
		ad.set_version('0.3.2')
		ad.set_copyright('Copyrignt (c) 2011\nLorenzo Carbonell')
		ad.set_comments(_('A simple application to translate'))
		ad.set_license(_(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.'))		
		ad.set_website('http://www.atareao.es')
		ad.set_website_label('http://www.atareao.es')
		ad.set_authors(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_translator_credits('Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>')		
		ad.set_program_name('Translate-me')
		ad.set_logo(gtk.gdk.pixbuf_new_from_file(comun.absfile('tm.svg')))
		ad.run()
		ad.hide()

	def load_preferences(self):
		encoder = Encoder()
		self.de = self.load_key('de',0)
		self.a = self.load_key('a',0)
		self.proxy = self.load_key('proxy',False)
		self.server = self.load_key('server','')
		self.port = self.load_key('port',0)
		self.user = self.load_key('user',encoder.encode(''))
		self.password = self.load_key('password',encoder.encode(''))
		self.font_from = self.load_key('font_from','Ubuntu 12')
		self.font_to = self.load_key('font_to','Ubuntu 12')
		#
		self.combobox1.set_active(self.de)
		self.combobox2.set_active(self.a)
		self.entry1.modify_font(pango.FontDescription(self.font_from))
		self.entry2.modify_font(pango.FontDescription(self.font_to))

	def load_key(self,key,defecto):
		gconfi = GConf()
		PATH = '/apps/translate-me/options/'+key
		try:
			valor = gconfi.get_key(PATH)
			return valor
		except ValueError:
			gconfi.set_key(PATH,defecto)
		return defecto		

if __name__ == "__main__":
	v = TM()
	v.run()
	exit(0)

